package chap05.program02

object Main {
  def main(args: Array[String]) :Unit = {
    var list = (1 to 100000).toList // 1から100000までのリストを作成

    var amount = sumList(list)
    println(amount)
  }

  // リスト2 スタックオーバーフローになる例
  def sumList(list:List[Int]) :Int = {
    list match {
      case Nil => 0
      case x::xs => x + sumList(xs)
    }
  }

  // リスト3 アキュムレータの導入
//  def sumList(list:List[Int]) :Int = {
//    def sumListLocal(accumulator:Int ,list:List[Int]) :Int = {
//      list match {
//        case Nil => accumulator
//        case ::(x, xs) => sumListLocal(accumulator + x, xs)
//      }
//    }
//
//    sumListLocal(0, list)
//  }
}
