package chap08.misc

import scala.collection.mutable.ListBuffer

class HelloMonitor {
  val values = new ListBuffer[Int]

  def take() = synchronized {
    while (values.size == 0) {
      wait()
    }
    values.remove(0)
  }

  def put(value: Int) = synchronized {
    values.append(value)
    notifyAll()
  }
}
