package chap10.program06

import scala.util.parsing.combinator._

class CombinatorParser extends JavaTokenParsers {
  def parse(data: String) = parseAll(expression, data)

  // <式> ::= <数字> + <数字> | <数字> - <数字> | <数字>
  def expression: Parser[Any] = 
    (number~"+"~number) | (number~"-"~number) | number
  // <数字> ::= 0|1|2|3|4|5|6|7|8|9
  def number: Parser[String] = """[0-9]""".r
}
